
package de.ivu.elect.presentation.niederschrift;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturConversationStore;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturExtendedDAO;
import de.ivu.elect.business.niederschrift.boundary.NiederschriftKorrekturEdit;
import de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur;
import de.ivu.elect.business.niederschrift.entity.NiederschriftKorrekturMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractNiederschriftKorrekturEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractNiederschriftKorrekturEditNoScopeView.VIEW_ID, useCase = UseCasePermission.NIEDERSCHRIFT_KORREKTUR_EDIT)
public abstract class AbstractNiederschriftKorrekturEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<NiederschriftKorrektur>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "niederschriftKorrekturEditView";

  public static final String VIEW_ID = "/niederschrift/niederschrift-korrektur-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/niederschrift/niederschrift-korrektur-search.xhtml";

  @Inject
  protected transient NiederschriftKorrekturExtendedDAO extendedDAO;

  @Inject
  protected transient NiederschriftKorrekturEdit edit;

  @Inject
  @ConversationGroup(NiederschriftKorrekturConversationStore.class)
  protected transient NiederschriftKorrekturConversationStore conversationStore;

  @Inject
  protected transient NiederschriftKorrekturMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient NiederschriftKorrekturEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public NiederschriftKorrektur getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(NiederschriftKorrektur entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.NIEDERSCHRIFT_KORREKTUR_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(NiederschriftKorrektur entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.NIEDERSCHRIFT_KORREKTUR_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.NIEDERSCHRIFT_KORREKTUR_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.NIEDERSCHRIFT_KORREKTUR_EDIT)
  @Override
  public String save() {
    NiederschriftKorrektur entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(NiederschriftKorrektur entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    NiederschriftKorrektur entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(NiederschriftKorrektur entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.NIEDERSCHRIFT_KORREKTUR_EDIT);
  }
  
  @Redirect
  public String edit(NiederschriftKorrektur entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class NiederschriftKorrekturEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<NiederschriftKorrektur,   de.ivu.elect.business.niederschrift.entity.NiederschriftKorrekturPK  > {

    private static final long serialVersionUID = 1L;
  }
}
